﻿using ProjectSeaplane.DrawningObjects;
using ProjectSeaplane.Generics;
using ProjectSeaplane.MovementStrategy;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProjectSeaplane
{
    public partial class FormPlaneCollection : Form
    {
        /// <summary>
        /// Набор объектов
        /// </summary>
        private readonly PlanesGenericCollection<DrawningPlane,
            DrawningObjectPlane> _planes;
        /// <summary>
        /// Конструктор
        /// </summary>
        public FormPlaneCollection()
        {
            InitializeComponent();
            _planes = new PlanesGenericCollection<DrawningPlane,
                DrawningObjectPlane>(pictureBoxCollection.Width, pictureBoxCollection.Height);
        }
        /// <summary>
        /// Добавление объекта в набор
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonAddPlane_Click(object sender, EventArgs e)
        {
            FormSeaplane form = new FormSeaplane();
            if (form.ShowDialog() == DialogResult.OK)
            {
                if (_planes + form.SelectedPlane != -1)
                {
                    MessageBox.Show("Объект добавлен");
                    pictureBoxCollection.Image = _planes.ShowPlanes();
                }
                else
                {
                    MessageBox.Show("Не удалось добавить объект");
                }
            }
        }
        /// <summary>
        /// Удаление объекта из набора
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonRemovePlane_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Удалить объект?", "Удаление",
            MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                return;
            }
            int pos = -1;
            try
            {
                pos = Convert.ToInt32(maskedTextBoxNumber.Text);
            }
            catch (Exception ex) { }
            if (_planes - pos)
            {
                MessageBox.Show("Объект удален");
                pictureBoxCollection.Image = _planes.ShowPlanes();
            }
            else
            {
                MessageBox.Show("Не удалось удалить объект");
            }
        }
        /// <summary>
        /// Обновление рисунка по набору
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonRefreshCollection_Click(object sender, EventArgs e)
        {
            pictureBoxCollection.Image = _planes.ShowPlanes();
        }
    }
}
